pip download

Usage


pip download [options] <requirement specifier> [package-index-options] ...
pip download [options] -r <requirements file> [package-index-options] ...
pip download [options] <vcs project url> ...
pip download [options] <local project path> ...
pip download [options] <archive url/path> ...

Description

Download packages from:

  • PyPI (and other indexes) using requirement specifiers.
  • VCS project urls.
  • Local project directories.
  • Local or remote source archives.

pip also supports downloading from "requirements files", which provide an easy way to specify a whole environment to be downloaded.

Overview

pip download does the same resolution and downloading as pip install, but instead of installing the dependencies, it collects the downloaded distributions into the directory provided (defaulting to the current directory). This directory can later be passed as the value to pip install --find-links to facilitate offline or locked down package installation.

pip download with the --platform, --python-version, --implementation, and --abi options provides the ability to fetch dependencies for an interpreter and system other than the ones that pip is running on. --only-binary=:all: is required when using any of these options. It is important to note that these options all default to the current system/interpreter, and not to the most restrictive constraints (e.g. platform any, abi none, etc). To avoid fetching dependencies that happen to match the constraint of the current interpreter (but not your target one), it is recommended to specify all of these options if you are specifying one of them. Generic dependencies (e.g. universal wheels, or dependencies with no platform, abi, or implementation constraints) will still match an over- constrained download requirement.

Options

-c, --constraint <file>

Constrain versions using the given constraints file. This option can be used multiple times.

-r, --requirement <file>

Install from the given requirements file. This option can be used multiple times.

-b, --build <dir>

Directory to unpack packages into and build in.

--no-deps

Don't install package dependencies.

--global-option <options>

Extra global options to be supplied to the setup.py call before the install command.

--no-binary <format_control>

Do not use binary packages. Can be supplied multiple times, and each time adds to the existing value. Accepts either :all: to disable all binary packages, :none: to empty the set, or one or more package names with commas between them. Note that some packages are tricky to compile and may fail to install when this option is used on them.

--only-binary <format_control>

Do not use source packages. Can be supplied multiple times, and each time adds to the existing value. Accepts either :all: to disable all source packages, :none: to empty the set, or one or more package names with commas between them. Packages without binary distributions will fail to install when this option is used on them.

--src <dir>

Directory to check out editable projects into. The default in a virtualenv is "<venv path>/src". The default for global installs is "<current dir>/src".

--pre

Include pre-release and development versions. By default, pip only finds stable versions.

--no-clean

Don't clean up build directories.

--require-hashes

Require a hash to check each requirement against, for repeatable installs. This option is implied when any package in a requirements file has a --hash option.

--progress-bar <progress_bar>

Specify type of progress to be displayed [off|emoji|on|pretty|ascii] (default: on)

-d, --dest <dir>

Download packages into <dir>.

--platform <platform>

Only download wheels compatible with <platform>. Defaults to the platform of the running system.

--python-version <python_version>

Only download wheels compatible with Python interpreter version <version>. If not specified, then the current system interpreter minor version is used. A major version (e.g. '2') can be specified to match all minor revs of that major version. A minor version (e.g. '34') can also be specified.

--implementation <implementation>

Only download wheels compatible with Python implementation <implementation>, e.g. 'pp', 'jy', 'cp', or 'ip'. If not specified, then the current interpreter implementation is used. Use 'py' to force implementation-agnostic wheels.

--abi <abi>

Only download wheels compatible with Python abi <abi>, e.g. 'pypy_41'. If not specified, then the current interpreter abi tag is used. Generally you will need to specify --implementation, --platform, and --python-version when using this option.

-i, --index-url <url>

Base URL of Python Package Index (default https://pypi.python.org/simple). This should point to a repository compliant with PEP 503 (the simple repository API) or a local directory laid out in the same format.

--extra-index-url <url>

Extra URLs of package indexes to use in addition to --index-url. Should follow the same rules as --index-url.

--no-index

Ignore package index (only looking at --find-links URLs instead).

-f, --find-links <url>

If a url or path to an html file, then parse for links to archives. If a local path or file:// url that's a directory, then look for archives in the directory listing.

Enable the processing of dependency links.

Examples

  1. Download a package and all of its dependencies

    $ pip download SomePackage
    $ pip download -d . SomePackage  # equivalent to above
    $ pip download --no-index --find-links=/tmp/wheelhouse -d /tmp/otherwheelhouse SomePackage
    
  2. Download a package and all of its dependencies with OSX specific interpreter constraints.

    This forces OSX 10.10 or lower compatibility. Since OSX deps are forward compatible, this will also match macosx-10_9_x86_64, macosx-10_8_x86_64, macosx-10_8_intel, etc. It will also match deps with platform any. Also force the interpreter version to 27 (or more generic, i.e. 2) and implementation to cp (or more generic, i.e. py).

    $ pip download \
        --only-binary=:all: \
        --platform macosx-10_10_x86_64 \
        --python-version 27 \
        --implementation cp \
        SomePackage
    
  3. Download a package and its dependencies with linux specific constraints.

    Force the interpreter to be any minor version of py3k, and only accept cp34m or none as the abi.

    $ pip download \
        --only-binary=:all: \
        --platform linux_x86_64 \
        --python-version 3 \
        --implementation cp \
        --abi cp34m \
        SomePackage
    
  4. Force platform, implementation, and abi agnostic deps.

    $ pip download \
        --only-binary=:all: \
        --platform any \
        --python-version 3 \
        --implementation py \
        --abi none \
        SomePackage
    
  5. Even when overconstrained, this will still correctly fetch the pip universal wheel.

    $ pip download \
        --only-binary=:all: \
        --platform linux_x86_64 \
        --python-version 33 \
        --implementation cp \
        --abi cp34m \
        pip>=8
    $ ls pip-8.1.1-py2.py3-none-any.whl
    pip-8.1.1-py2.py3-none-any.whl